diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_type.c openssl-1.0.0q/crypto/asn1/a_type.c
--- openssl-1.0.0q.orig/crypto/asn1/a_type.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_type.c	2017-04-25 16:23:39.853529985 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/objects.h>
 
@@ -80,7 +82,7 @@
 	if (type == V_ASN1_BOOLEAN)
 		a->value.boolean = value ? 0xff : 0;
 	else
-		a->value.ptr=value;
+		a->value.ptr=(char *)value;
 	}
 
 int ASN1_TYPE_set1(ASN1_TYPE *a, int type, const void *value)
@@ -93,7 +95,7 @@
 	else if (type == V_ASN1_OBJECT)
 		{
 		ASN1_OBJECT *odup;
-		odup = OBJ_dup(value);
+		odup = OBJ_dup((ASN1_OBJECT *)value);
 		if (!odup)
 			return 0;
 		ASN1_TYPE_set(a, type, odup);
@@ -101,7 +103,7 @@
 	else
 		{
 		ASN1_STRING *sdup;
-		sdup = ASN1_STRING_dup(value);
+		sdup = ASN1_STRING_dup((const ASN1_STRING *)value);
 		if (!sdup)
 			return 0;
 		ASN1_TYPE_set(a, type, sdup);
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_utctm.c openssl-1.0.0q/crypto/asn1/a_utctm.c
--- openssl-1.0.0q.orig/crypto/asn1/a_utctm.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_utctm.c	2017-04-25 16:23:39.855528283 +0200
@@ -56,10 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
-#include "cryptlib.h"
-#include "o_time.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#include <openssl/o_time.h>
 #include <openssl/asn1.h>
 
 #if 0
@@ -71,7 +73,7 @@
 #else
 	/* KLUDGE! We convert to ascii before writing DER */
 	int len;
-	char tmp[24];
+	char tmp[24]; /* ARRAY OK UNUSED 2009-05-25 yngve EBCDIC only*/
 	ASN1_STRING x = *(ASN1_STRING *)a;
 
 	len = x.length;
@@ -162,12 +164,13 @@
 	return(0);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_UTCTIME_set_string(ASN1_UTCTIME *s, const char *str)
 	{
 	ASN1_UTCTIME t;
 
 	t.type=V_ASN1_UTCTIME;
-	t.length=strlen(str);
+	t.length=op_strlen(str);
 	t.data=(unsigned char *)str;
 	if (ASN1_UTCTIME_check(&t))
 		{
@@ -183,6 +186,7 @@
 	else
 		return(0);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 ASN1_UTCTIME *ASN1_UTCTIME_set(ASN1_UTCTIME *s, time_t t)
 	{
@@ -192,6 +196,8 @@
 ASN1_UTCTIME *ASN1_UTCTIME_adj(ASN1_UTCTIME *s, time_t t,
 				int offset_day, long offset_sec)
 	{
+	ASN1_UTCTIME *alloced = NULL;
+
 	char *p;
 	struct tm *ts;
 	struct tm data;
@@ -201,7 +207,7 @@
 	if (s == NULL)
 		{
 		free_s = 1;
-		s=M_ASN1_UTCTIME_new();
+		alloced = s=M_ASN1_UTCTIME_new();
 		}
 	if (s == NULL)
 		goto err;
@@ -209,12 +215,20 @@
 
 	ts=OPENSSL_gmtime(&t, &data);
 	if (ts == NULL)
-		goto err;
+		{
+		if(alloced)
+			M_ASN1_UTCTIME_free(alloced);
+ 		return(NULL);
+		}
 
 	if (offset_day || offset_sec)
 		{ 
 		if (!OPENSSL_gmtime_adj(ts, offset_day, offset_sec))
-			goto err;
+			{
+			if(alloced)
+				M_ASN1_UTCTIME_free(alloced);
+ 			return NULL;
+			}
 		}
 
 	if((ts->tm_year < 50) || (ts->tm_year >= 150))
@@ -223,9 +237,11 @@
 	p=(char *)s->data;
 	if ((p == NULL) || ((size_t)s->length < len))
 		{
-		p=OPENSSL_malloc(len);
+		p=(char *)OPENSSL_malloc(len);
 		if (p == NULL)
 			{
+			if(alloced)
+				M_ASN1_UTCTIME_free(alloced);
 			ASN1err(ASN1_F_ASN1_UTCTIME_ADJ,ERR_R_MALLOC_FAILURE);
 			goto err;
 			}
@@ -236,7 +252,7 @@
 
 	BIO_snprintf(p,len,"%02d%02d%02d%02d%02d%02dZ",ts->tm_year%100,
 		     ts->tm_mon+1,ts->tm_mday,ts->tm_hour,ts->tm_min,ts->tm_sec);
-	s->length=strlen(p);
+	s->length=op_strlen(p);
 	s->type=V_ASN1_UTCTIME;
 #ifdef CHARSET_EBCDIC_not
 	ebcdic2ascii(s->data, s->data, s->length);
@@ -249,6 +265,7 @@
 	}
 
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_UTCTIME_cmp_time_t(const ASN1_UTCTIME *s, time_t t)
 	{
 	struct tm *tm;
@@ -270,6 +287,9 @@
 	t -= offset*60; /* FIXME: may overflow in extreme cases */
 
 	tm = OPENSSL_gmtime(&t, &data);
+
+	if(tm == NULL)
+		return 1;
 	
 #define return_cmp(a,b) if ((a)<(b)) return -1; else if ((a)>(b)) return 1
 	year = g2(s->data);
@@ -286,6 +306,7 @@
 
 	return 0;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 
 #if 0
@@ -294,7 +315,7 @@
 	struct tm tm;
 	int offset;
 
-	memset(&tm,'\0',sizeof tm);
+	op_memset(&tm,'\0',sizeof tm);
 
 #define g2(p) (((p)[0]-'0')*10+(p)[1]-'0')
 	tm.tm_year=g2(s->data);
@@ -315,7 +336,7 @@
 		}
 #undef g2
 
-	return mktime(&tm)-offset*60; /* FIXME: mktime assumes the current timezone
+	return op_mktime(&tm)-offset*60; /* FIXME: mktime assumes the current timezone
 	                               * instead of UTC, and unless we rewrite OpenSSL
 				       * in Lisp we cannot locally change the timezone
 				       * without possibly interfering with other parts
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_utf8.c openssl-1.0.0q/crypto/asn1/a_utf8.c
--- openssl-1.0.0q.orig/crypto/asn1/a_utf8.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_utf8.c	2017-04-25 16:23:39.857528258 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_verify.c openssl-1.0.0q/crypto/asn1/a_verify.c
--- openssl-1.0.0q.orig/crypto/asn1/a_verify.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_verify.c	2017-04-25 16:23:39.859527674 +0200
@@ -56,14 +56,18 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include "asn1_locl.h"
 
 #ifndef NO_SYS_TYPES_H
+#ifndef OPERA_SMALL_VERSION
 # include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 #include <openssl/bn.h>
@@ -74,6 +78,7 @@
 
 #ifndef NO_ASN1_OLD
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_verify(i2d_of_void *i2d, X509_ALGOR *a, ASN1_BIT_STRING *signature,
 		char *data, EVP_PKEY *pkey)
 	{
@@ -122,12 +127,13 @@
 		}
 	/* we don't need to zero the 'ctx' because we just checked
 	 * public information */
-	/* memset(&ctx,0,sizeof(ctx)); */
+	/* op_memset(&ctx,0,sizeof(ctx)); */
 	ret=1;
 err:
 	EVP_MD_CTX_cleanup(&ctx);
 	return(ret);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 #endif
 
@@ -183,7 +189,7 @@
 		goto err;
 		}
 
-	inl = ASN1_item_i2d(asn, &buf_in, it);
+	inl = ASN1_item_i2d((ASN1_VALUE *) asn, &buf_in, it);
 	
 	if (buf_in == NULL)
 		{
@@ -205,7 +211,7 @@
 		}
 	/* we don't need to zero the 'ctx' because we just checked
 	 * public information */
-	/* memset(&ctx,0,sizeof(ctx)); */
+	/* op_memset(&ctx,0,sizeof(ctx)); */
 	ret=1;
 err:
 	EVP_MD_CTX_cleanup(&ctx);
diff -Naur openssl-1.0.0q.orig/crypto/asn1/ameth_lib.c openssl-1.0.0q/crypto/asn1/ameth_lib.c
--- openssl-1.0.0q.orig/crypto/asn1/ameth_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/ameth_lib.c	2017-04-25 16:23:39.861527649 +0200
@@ -55,43 +55,72 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #ifndef OPENSSL_NO_ENGINE
 #include <openssl/engine.h>
 #endif
 #include "asn1_locl.h"
+#include "modules/libopeay/libopeay_arrays.h"
+
+
+#define   rsa_asn1_meth0 OPENSSL_GLOBAL_ITEM_NAME(rsa_ameth__rsa_asn1_meth0)
+#define   rsa_asn1_meth1 OPENSSL_GLOBAL_ITEM_NAME(rsa_ameth__rsa_asn1_meth1)
+
+#define   dsa_asn1_meth0 OPENSSL_GLOBAL_ITEM_NAME(dsa_ameth__dsa_asn1_meth0)
+#define   dsa_asn1_meth1 OPENSSL_GLOBAL_ITEM_NAME(dsa_ameth__dsa_asn1_meth1)
+#define   dsa_asn1_meth2 OPENSSL_GLOBAL_ITEM_NAME(dsa_ameth__dsa_asn1_meth2)
+#define   dsa_asn1_meth3 OPENSSL_GLOBAL_ITEM_NAME(dsa_ameth__dsa_asn1_meth3)
+#define   dsa_asn1_meth4 OPENSSL_GLOBAL_ITEM_NAME(dsa_ameth__dsa_asn1_meth4)
+
+#define    dh_asn1_meth  OPENSSL_GLOBAL_ITEM_NAME(dh_ameth__dh_asn1_meth)
+#define eckey_asn1_meth  OPENSSL_GLOBAL_ITEM_NAME(ec_ameth__eckey_asn1_meth)
+#define  hmac_asn1_meth  OPENSSL_GLOBAL_ITEM_NAME(hm_ameth__hmac_asn1_meth)
+
+#ifdef HAS_COMPLEX_GLOBALS
+extern const EVP_PKEY_ASN1_METHOD rsa_asn1_meth0;
+extern const EVP_PKEY_ASN1_METHOD rsa_asn1_meth1;
+
+extern const EVP_PKEY_ASN1_METHOD dsa_asn1_meth0;
+extern const EVP_PKEY_ASN1_METHOD dsa_asn1_meth1;
+extern const EVP_PKEY_ASN1_METHOD dsa_asn1_meth2;
+extern const EVP_PKEY_ASN1_METHOD dsa_asn1_meth3;
+extern const EVP_PKEY_ASN1_METHOD dsa_asn1_meth4;
 
 extern const EVP_PKEY_ASN1_METHOD rsa_asn1_meths[];
 extern const EVP_PKEY_ASN1_METHOD dsa_asn1_meths[];
 extern const EVP_PKEY_ASN1_METHOD dh_asn1_meth;
 extern const EVP_PKEY_ASN1_METHOD eckey_asn1_meth;
 extern const EVP_PKEY_ASN1_METHOD hmac_asn1_meth;
+#endif // HAS_COMPLEX_GLOBALS
 
 /* Keep this sorted in type order !! */
-static const EVP_PKEY_ASN1_METHOD *standard_methods[] = 
-	{
+OPENSSL_PREFIX_CONST_ARRAY(static, const EVP_PKEY_ASN1_METHOD*, ameth_lib__standard_methods, libopeay)
 #ifndef OPENSSL_NO_RSA
-	&rsa_asn1_meths[0],
-	&rsa_asn1_meths[1],
+	CONST_ENTRY(&rsa_asn1_meth0)
+	CONST_ENTRY(&rsa_asn1_meth1)
 #endif
 #ifndef OPENSSL_NO_DH
-	&dh_asn1_meth,
+	CONST_ENTRY(&dh_asn1_meth)
 #endif
 #ifndef OPENSSL_NO_DSA
-	&dsa_asn1_meths[0],
-	&dsa_asn1_meths[1],
-	&dsa_asn1_meths[2],
-	&dsa_asn1_meths[3],
-	&dsa_asn1_meths[4],
+	CONST_ENTRY(&dsa_asn1_meth0)
+	CONST_ENTRY(&dsa_asn1_meth1)
+	CONST_ENTRY(&dsa_asn1_meth2)
+	CONST_ENTRY(&dsa_asn1_meth3)
+	CONST_ENTRY(&dsa_asn1_meth4)
 #endif
 #ifndef OPENSSL_NO_EC
-	&eckey_asn1_meth,
+	CONST_ENTRY(&eckey_asn1_meth)
 #endif
-	&hmac_asn1_meth
-	};
+	CONST_ENTRY(&hmac_asn1_meth)
+CONST_END(ameth_lib__standard_methods)
+#define standard_methods OPENSSL_GLOBAL_ARRAY_NAME(ameth_lib__standard_methods)
 
 typedef int sk_cmp_fn_type(const char * const *a, const char * const *b);
 DECLARE_STACK_OF(EVP_PKEY_ASN1_METHOD)
@@ -104,7 +133,7 @@
 	{
 	int i;
 	for (i = 0;
-		i < sizeof(standard_methods)/sizeof(EVP_PKEY_ASN1_METHOD *);
+		i < OPENSSL_CONST_ARRAY_SIZE(ameth_lib__standard_methods);
 		i++)
 		fprintf(stderr, "Number %d id=%d (%s)\n", i,
 			standard_methods[i]->pkey_id,
@@ -126,7 +155,7 @@
 
 int EVP_PKEY_asn1_get_count(void)
 	{
-	int num = sizeof(standard_methods)/sizeof(EVP_PKEY_ASN1_METHOD *);
+	int num = OPENSSL_CONST_ARRAY_SIZE(ameth_lib__standard_methods);
 	if (app_methods)
 		num += sk_EVP_PKEY_ASN1_METHOD_num(app_methods);
 	return num;
@@ -134,7 +163,7 @@
 
 const EVP_PKEY_ASN1_METHOD *EVP_PKEY_asn1_get0(int idx)
 	{
-	int num = sizeof(standard_methods)/sizeof(EVP_PKEY_ASN1_METHOD *);
+	int num = OPENSSL_CONST_ARRAY_SIZE(ameth_lib__standard_methods);
 	if (idx < 0)
 		return NULL; 
 	if (idx < num)
@@ -156,8 +185,7 @@
 			return sk_EVP_PKEY_ASN1_METHOD_value(app_methods, idx);
 		}
 	ret = OBJ_bsearch_ameth(&t, standard_methods,
-			  sizeof(standard_methods)
-			  /sizeof(EVP_PKEY_ASN1_METHOD *));
+			OPENSSL_CONST_ARRAY_SIZE(ameth_lib__standard_methods));
 	if (!ret || !*ret)
 		return NULL;
 	return *ret;
@@ -292,7 +320,7 @@
 					const char *pem_str, const char *info)
 	{
 	EVP_PKEY_ASN1_METHOD *ameth;
-	ameth = OPENSSL_malloc(sizeof(EVP_PKEY_ASN1_METHOD));
+	ameth = (EVP_PKEY_ASN1_METHOD *)OPENSSL_malloc(sizeof(EVP_PKEY_ASN1_METHOD));
 	if (!ameth)
 		return NULL;
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn1.h openssl-1.0.0q/crypto/asn1/asn1.h
--- openssl-1.0.0q.orig/crypto/asn1/asn1.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn1.h	2017-04-25 16:23:39.865527878 +0200
@@ -59,7 +59,9 @@
 #ifndef HEADER_ASN1_H
 #define HEADER_ASN1_H
 
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/e_os2.h>
 #ifndef OPENSSL_NO_BIO
 #include <openssl/bio.h>
@@ -406,12 +408,25 @@
 #define ASN1_ITEM_ptr(iptr) (iptr)
 
 /* Macro to include ASN1_ITEM pointer from base type */
+#ifndef OPERA_SMALL_VERSION
 #define ASN1_ITEM_ref(iptr) (&(iptr##_it))
 
 #define ASN1_ITEM_rptr(ref) (&(ref##_it))
 
 #define DECLARE_ASN1_ITEM(name) \
 	OPENSSL_EXTERN const ASN1_ITEM name##_it;
+#else // OPERA_SMALL_VERSION
+#define ASN1_ITEM_ref(iptr) (&(OPENSSL_GLOBAL_ITEM_NAME(iptr##_it)))
+
+#define ASN1_ITEM_rptr(ref) (&(OPENSSL_GLOBAL_ITEM_NAME(ref##_it)))
+
+#ifdef HAS_COMPLEX_GLOBALS
+#define DECLARE_ASN1_ITEM(name) \
+	OPENSSL_EXTERN const ASN1_ITEM g_##name##_it;
+#else
+#define DECLARE_ASN1_ITEM(name)
+#endif
+#endif // OPERA_SMALL_VERSION
 
 #else
 
@@ -570,6 +585,11 @@
 	const char *sname;
 } BIT_STRING_BITNAME;
 
+#define CONST_BIT_STRING_BITNAME_ENTRY(num, _lname, _sname) \
+	CONST_ENTRY_START(bitnum,num)\
+	CONST_ENTRY_SINGLE(lname,_lname)\
+	CONST_ENTRY_SINGLE(sname,_sname)\
+	CONST_ENTRY_END
 
 #define M_ASN1_STRING_length(x)	((x)->length)
 #define M_ASN1_STRING_length_set(x, n)	((x)->length = (n))
diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn1_err.c openssl-1.0.0q/crypto/asn1/asn1_err.c
--- openssl-1.0.0q.orig/crypto/asn1/asn1_err.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn1_err.c	2017-04-25 16:23:39.866528285 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/asn1.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn1_gen.c openssl-1.0.0q/crypto/asn1/asn1_gen.c
--- openssl-1.0.0q.orig/crypto/asn1/asn1_gen.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn1_gen.c	2017-04-25 16:23:39.869527269 +0200
@@ -56,9 +56,10 @@
  *
  */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 #define ASN1_GEN_FLAG		0x10000
 #define ASN1_GEN_FLAG_IMP	(ASN1_GEN_FLAG|1)
@@ -70,7 +71,10 @@
 #define ASN1_GEN_FLAG_SETWRAP	(ASN1_GEN_FLAG|7)
 #define ASN1_GEN_FLAG_FORMAT	(ASN1_GEN_FLAG|8)
 
+#ifndef OPERA_SMALL_VERSION
+// For Opera-specific-version, see close to definition of asn1_gen__tnst.
 #define ASN1_GEN_STR(str,val)	{str, sizeof(str) - 1, val}
+#endif // !OPERA_SMALL_VERSION
 
 #define ASN1_FLAG_EXP_MAX	20
 
@@ -121,6 +125,7 @@
 static ASN1_TYPE *asn1_str2type(const char *str, int format, int utype);
 static int asn1_str2tag(const char *tagstr, int len);
 
+#ifndef OPERA_SMALL_VERSION
 ASN1_TYPE *ASN1_generate_nconf(char *str, CONF *nconf)
 	{
 	X509V3_CTX cnf;
@@ -131,6 +136,7 @@
 	X509V3_set_nconf(&cnf, nconf);
 	return ASN1_generate_v3(str, &cnf);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 ASN1_TYPE *ASN1_generate_v3(char *str, X509V3_CTX *cnf)
 	{
@@ -149,6 +155,9 @@
 	int hdr_constructed = 0, hdr_tag, hdr_class;
 	int r;
 
+	/* Suppress warning "potentially uninitialized local variable used". */
+	hdr_len = 0;
+
 	asn1_tags.imp_tag = -1;
 	asn1_tags.imp_class = -1;
 	asn1_tags.format = ASN1_GEN_FORMAT_ASCII;
@@ -226,7 +235,7 @@
 
 	/* Allocate buffer for new encoding */
 
-	new_der = OPENSSL_malloc(len);
+	new_der = (unsigned char *)OPENSSL_malloc(len);
 	if (!new_der)
 		goto err;
 
@@ -276,7 +285,7 @@
 
 static int asn1_cb(const char *elem, int len, void *bitstr)
 	{
-	tag_exp_arg *arg = bitstr;
+	tag_exp_arg *arg = (tag_exp_arg *)bitstr;
 	int i;
 	int utype;
 	int vlen = 0;
@@ -549,75 +558,80 @@
 	}
 
 
+#define ASN1_GEN_STR(str,val)	CONST_TRIPLE_ENTRY(strnam, str, len, sizeof(str) - 1, tag, val)
+OPENSSL_PREFIX_CONST_ARRAY(static, struct tag_name_st, asn1_gen__tnst, libopeay)
+	ASN1_GEN_STR("BOOL", V_ASN1_BOOLEAN)
+	ASN1_GEN_STR("BOOLEAN", V_ASN1_BOOLEAN)
+	ASN1_GEN_STR("NULL", V_ASN1_NULL)
+	ASN1_GEN_STR("INT", V_ASN1_INTEGER)
+	ASN1_GEN_STR("INTEGER", V_ASN1_INTEGER)
+	ASN1_GEN_STR("ENUM", V_ASN1_ENUMERATED)
+	ASN1_GEN_STR("ENUMERATED", V_ASN1_ENUMERATED)
+	ASN1_GEN_STR("OID", V_ASN1_OBJECT)
+	ASN1_GEN_STR("OBJECT", V_ASN1_OBJECT)
+	ASN1_GEN_STR("UTCTIME", V_ASN1_UTCTIME)
+	ASN1_GEN_STR("UTC", V_ASN1_UTCTIME)
+	ASN1_GEN_STR("GENERALIZEDTIME", V_ASN1_GENERALIZEDTIME)
+	ASN1_GEN_STR("GENTIME", V_ASN1_GENERALIZEDTIME)
+	ASN1_GEN_STR("OCT", V_ASN1_OCTET_STRING)
+	ASN1_GEN_STR("OCTETSTRING", V_ASN1_OCTET_STRING)
+	ASN1_GEN_STR("BITSTR", V_ASN1_BIT_STRING)
+	ASN1_GEN_STR("BITSTRING", V_ASN1_BIT_STRING)
+	ASN1_GEN_STR("UNIVERSALSTRING", V_ASN1_UNIVERSALSTRING)
+	ASN1_GEN_STR("UNIV", V_ASN1_UNIVERSALSTRING)
+	ASN1_GEN_STR("IA5", V_ASN1_IA5STRING)
+	ASN1_GEN_STR("IA5STRING", V_ASN1_IA5STRING)
+	ASN1_GEN_STR("UTF8", V_ASN1_UTF8STRING)
+	ASN1_GEN_STR("UTF8String", V_ASN1_UTF8STRING)
+	ASN1_GEN_STR("BMP", V_ASN1_BMPSTRING)
+	ASN1_GEN_STR("BMPSTRING", V_ASN1_BMPSTRING)
+	ASN1_GEN_STR("VISIBLESTRING", V_ASN1_VISIBLESTRING)
+	ASN1_GEN_STR("VISIBLE", V_ASN1_VISIBLESTRING)
+	ASN1_GEN_STR("PRINTABLESTRING", V_ASN1_PRINTABLESTRING)
+	ASN1_GEN_STR("PRINTABLE", V_ASN1_PRINTABLESTRING)
+	ASN1_GEN_STR("T61", V_ASN1_T61STRING)
+	ASN1_GEN_STR("T61STRING", V_ASN1_T61STRING)
+	ASN1_GEN_STR("TELETEXSTRING", V_ASN1_T61STRING)
+	ASN1_GEN_STR("GeneralString", V_ASN1_GENERALSTRING)
+	ASN1_GEN_STR("GENSTR", V_ASN1_GENERALSTRING)
+	ASN1_GEN_STR("NUMERIC", V_ASN1_NUMERICSTRING)
+	ASN1_GEN_STR("NUMERICSTRING", V_ASN1_NUMERICSTRING)
+
+	/* Special cases */
+	ASN1_GEN_STR("SEQUENCE", V_ASN1_SEQUENCE)
+	ASN1_GEN_STR("SEQ", V_ASN1_SEQUENCE)
+	ASN1_GEN_STR("SET", V_ASN1_SET)
+	/* type modifiers */
+	/* Explicit tag */
+	ASN1_GEN_STR("EXP", ASN1_GEN_FLAG_EXP)
+	ASN1_GEN_STR("EXPLICIT", ASN1_GEN_FLAG_EXP)
+	/* Implicit tag */
+	ASN1_GEN_STR("IMP", ASN1_GEN_FLAG_IMP)
+	ASN1_GEN_STR("IMPLICIT", ASN1_GEN_FLAG_IMP)
+	/* OCTET STRING wrapper */
+	ASN1_GEN_STR("OCTWRAP", ASN1_GEN_FLAG_OCTWRAP)
+	/* SEQUENCE wrapper */
+	ASN1_GEN_STR("SEQWRAP", ASN1_GEN_FLAG_SEQWRAP)
+	/* SET wrapper */
+	ASN1_GEN_STR("SETWRAP", ASN1_GEN_FLAG_SETWRAP)
+	/* BIT STRING wrapper */
+	ASN1_GEN_STR("BITWRAP", ASN1_GEN_FLAG_BITWRAP)
+	ASN1_GEN_STR("FORM", ASN1_GEN_FLAG_FORMAT)
+	ASN1_GEN_STR("FORMAT", ASN1_GEN_FLAG_FORMAT)
+CONST_END(asn1_gen__tnst)
+#define tnst OPENSSL_GLOBAL_ARRAY_NAME(asn1_gen__tnst)
+
+
 static int asn1_str2tag(const char *tagstr, int len)
 	{
 	unsigned int i;
-	static const struct tag_name_st *tntmp, tnst [] = {
-		ASN1_GEN_STR("BOOL", V_ASN1_BOOLEAN),
-		ASN1_GEN_STR("BOOLEAN", V_ASN1_BOOLEAN),
-		ASN1_GEN_STR("NULL", V_ASN1_NULL),
-		ASN1_GEN_STR("INT", V_ASN1_INTEGER),
-		ASN1_GEN_STR("INTEGER", V_ASN1_INTEGER),
-		ASN1_GEN_STR("ENUM", V_ASN1_ENUMERATED),
-		ASN1_GEN_STR("ENUMERATED", V_ASN1_ENUMERATED),
-		ASN1_GEN_STR("OID", V_ASN1_OBJECT),
-		ASN1_GEN_STR("OBJECT", V_ASN1_OBJECT),
-		ASN1_GEN_STR("UTCTIME", V_ASN1_UTCTIME),
-		ASN1_GEN_STR("UTC", V_ASN1_UTCTIME),
-		ASN1_GEN_STR("GENERALIZEDTIME", V_ASN1_GENERALIZEDTIME),
-		ASN1_GEN_STR("GENTIME", V_ASN1_GENERALIZEDTIME),
-		ASN1_GEN_STR("OCT", V_ASN1_OCTET_STRING),
-		ASN1_GEN_STR("OCTETSTRING", V_ASN1_OCTET_STRING),
-		ASN1_GEN_STR("BITSTR", V_ASN1_BIT_STRING),
-		ASN1_GEN_STR("BITSTRING", V_ASN1_BIT_STRING),
-		ASN1_GEN_STR("UNIVERSALSTRING", V_ASN1_UNIVERSALSTRING),
-		ASN1_GEN_STR("UNIV", V_ASN1_UNIVERSALSTRING),
-		ASN1_GEN_STR("IA5", V_ASN1_IA5STRING),
-		ASN1_GEN_STR("IA5STRING", V_ASN1_IA5STRING),
-		ASN1_GEN_STR("UTF8", V_ASN1_UTF8STRING),
-		ASN1_GEN_STR("UTF8String", V_ASN1_UTF8STRING),
-		ASN1_GEN_STR("BMP", V_ASN1_BMPSTRING),
-		ASN1_GEN_STR("BMPSTRING", V_ASN1_BMPSTRING),
-		ASN1_GEN_STR("VISIBLESTRING", V_ASN1_VISIBLESTRING),
-		ASN1_GEN_STR("VISIBLE", V_ASN1_VISIBLESTRING),
-		ASN1_GEN_STR("PRINTABLESTRING", V_ASN1_PRINTABLESTRING),
-		ASN1_GEN_STR("PRINTABLE", V_ASN1_PRINTABLESTRING),
-		ASN1_GEN_STR("T61", V_ASN1_T61STRING),
-		ASN1_GEN_STR("T61STRING", V_ASN1_T61STRING),
-		ASN1_GEN_STR("TELETEXSTRING", V_ASN1_T61STRING),
-		ASN1_GEN_STR("GeneralString", V_ASN1_GENERALSTRING),
-		ASN1_GEN_STR("GENSTR", V_ASN1_GENERALSTRING),
-		ASN1_GEN_STR("NUMERIC", V_ASN1_NUMERICSTRING),
-		ASN1_GEN_STR("NUMERICSTRING", V_ASN1_NUMERICSTRING),
-
-		/* Special cases */
-		ASN1_GEN_STR("SEQUENCE", V_ASN1_SEQUENCE),
-		ASN1_GEN_STR("SEQ", V_ASN1_SEQUENCE),
-		ASN1_GEN_STR("SET", V_ASN1_SET),
-		/* type modifiers */
-		/* Explicit tag */
-		ASN1_GEN_STR("EXP", ASN1_GEN_FLAG_EXP),
-		ASN1_GEN_STR("EXPLICIT", ASN1_GEN_FLAG_EXP),
-		/* Implicit tag */
-		ASN1_GEN_STR("IMP", ASN1_GEN_FLAG_IMP),
-		ASN1_GEN_STR("IMPLICIT", ASN1_GEN_FLAG_IMP),
-		/* OCTET STRING wrapper */
-		ASN1_GEN_STR("OCTWRAP", ASN1_GEN_FLAG_OCTWRAP),
-		/* SEQUENCE wrapper */
-		ASN1_GEN_STR("SEQWRAP", ASN1_GEN_FLAG_SEQWRAP),
-		/* SET wrapper */
-		ASN1_GEN_STR("SETWRAP", ASN1_GEN_FLAG_SETWRAP),
-		/* BIT STRING wrapper */
-		ASN1_GEN_STR("BITWRAP", ASN1_GEN_FLAG_BITWRAP),
-		ASN1_GEN_STR("FORM", ASN1_GEN_FLAG_FORMAT),
-		ASN1_GEN_STR("FORMAT", ASN1_GEN_FLAG_FORMAT),
-	};
+	const struct tag_name_st *tntmp;
 
 	if (len == -1)
 		len = strlen(tagstr);
 	
-	tntmp = tnst;	
-	for (i = 0; i < sizeof(tnst) / sizeof(struct tag_name_st); i++, tntmp++)
+	tntmp = tnst;
+	for (i = 0; i < OPENSSL_CONST_ARRAY_SIZE(asn1_gen__tnst); i++, tntmp++)
 		{
 		if ((len == tntmp->len) && !strncmp(tntmp->strnam, tagstr, len))
 			return tntmp->tag;
@@ -844,7 +858,7 @@
 		ASN1err(ASN1_F_BITSTR_CB, ASN1_R_INVALID_NUMBER);
 		return 0;
 		}
-	if (!ASN1_BIT_STRING_set_bit(bitstr, bitnum, 1))
+	if (!ASN1_BIT_STRING_set_bit((ASN1_BIT_STRING *)bitstr, bitnum, 1))
 		{
 		ASN1err(ASN1_F_BITSTR_CB, ERR_R_MALLOC_FAILURE);
 		return 0;
diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn1_lib.c openssl-1.0.0q/crypto/asn1/asn1_lib.c
--- openssl-1.0.0q.orig/crypto/asn1/asn1_lib.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn1_lib.c	2017-04-25 16:23:39.871528641 +0200
@@ -56,15 +56,19 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <limits.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1_mac.h>
 
 static int asn1_get_length(const unsigned char **pp,int *inf,long *rl,int max);
 static void asn1_put_length(unsigned char **pp, int length);
-const char ASN1_version[]="ASN.1" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char ASN1_version[]="ASN.1" OPENSSL_VERSION_PTEXT;  /* ARRAY OK 2007-02-27 haavardm */
+#endif /* !OPERA_SMALL_VERSION */
 
 static int _asn1_check_infinite_end(const unsigned char **p, long len)
 	{
@@ -80,10 +84,12 @@
 	return(0);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_check_infinite_end(unsigned char **p, long len)
 	{
 	return _asn1_check_infinite_end((const unsigned char **)p, len);
 	}
+#endif /* !OPERA_SMALL_VERSION */
 
 int ASN1_const_check_infinite_end(const unsigned char **p, long len)
 	{
@@ -173,7 +179,7 @@
 		i= *p&0x7f;
 		if (*(p++) & 0x80)
 			{
-			if (i > sizeof(long))
+			if (i > (int) sizeof(long))
 				return 0;
 			if (max-- == 0) return(0);
 			while (i-- > 0)
@@ -285,6 +291,7 @@
 	return(ret);
 	}
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 static int _asn1_Finish(ASN1_const_CTX *c)
 	{
 	if ((c->inf == (1|V_ASN1_CONSTRUCTED)) && (!c->eos))
@@ -313,6 +320,7 @@
 	{
 	return _asn1_Finish(c);
 	}
+#endif // !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 
 int asn1_GetSequence(ASN1_const_CTX *c, long *length)
 	{
@@ -373,22 +381,22 @@
 int ASN1_STRING_set(ASN1_STRING *str, const void *_data, int len)
 	{
 	unsigned char *c;
-	const char *data=_data;
+	const char *data= (const char *) _data;
 
 	if (len < 0)
 		{
 		if (data == NULL)
 			return(0);
 		else
-			len=strlen(data);
+			len=op_strlen(data);
 		}
 	if ((str->length < len) || (str->data == NULL))
 		{
 		c=str->data;
 		if (c == NULL)
-			str->data=OPENSSL_malloc(len+1);
+			str->data= (unsigned char *) OPENSSL_malloc(len+1);
 		else
-			str->data=OPENSSL_realloc(c,len+1);
+			str->data= (unsigned char *) OPENSSL_realloc(c,len+1);
 
 		if (str->data == NULL)
 			{
@@ -400,7 +408,7 @@
 	str->length=len;
 	if (data != NULL)
 		{
-		memcpy(str->data,data,len);
+		op_memcpy(str->data,data,len);
 		/* an allowance for strings :-) */
 		str->data[len]='\0';
 		}
@@ -411,7 +419,7 @@
 	{
 	if (str->data)
 		OPENSSL_free(str->data);
-	str->data = data;
+	str->data = (unsigned char *) data;
 	str->length = len;
 	}
 
@@ -453,7 +461,7 @@
 	i=(a->length-b->length);
 	if (i == 0)
 		{
-		i=memcmp(a->data,b->data,a->length);
+		i=op_memcmp(a->data,b->data,a->length);
 		if (i == 0)
 			return(a->type-b->type);
 		else
@@ -463,14 +471,16 @@
 		return(i);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 void asn1_add_error(const unsigned char *address, int offset)
 	{
-	char buf1[DECIMAL_SIZE(address)+1],buf2[DECIMAL_SIZE(offset)+1];
+	char buf1[DECIMAL_SIZE(address)+1],buf2[DECIMAL_SIZE(offset)+1];  /* ARRAY OK UNUSED OPERA 2004-02-18 yngve */
 
 	BIO_snprintf(buf1,sizeof buf1,"%lu",(unsigned long)address);
 	BIO_snprintf(buf2,sizeof buf2,"%d",offset);
 	ERR_add_error_data(4,"address=",buf1," offset=",buf2);
 	}
+#endif /* !OPERA_SMALL_VERSION */
 
 int ASN1_STRING_length(const ASN1_STRING *x)
 { return M_ASN1_STRING_length(x); }
diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn1_locl.h openssl-1.0.0q/crypto/asn1/asn1_locl.h
--- openssl-1.0.0q.orig/crypto/asn1/asn1_locl.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn1_locl.h	2017-04-25 16:23:39.873528336 +0200
@@ -56,6 +56,9 @@
  *
  */
 
+#ifndef HEADER_ASN1_LOCL_H
+#define HEADER_ASN1_LOCL_H
+
 /* Internal ASN1 structures and functions: not for application use */
 
 /* ASN1 print context structure */
@@ -114,6 +117,59 @@
 
 	} /* EVP_PKEY_ASN1_METHOD */;
 
+#define CONST_EVP_PKEY_ASN1_METHOD_ITEM(cname, \
+	a_pkey_id, \
+	a_pkey_base_id, \
+	a_pkey_flags, \
+	a_pem_str, \
+	a_info, \
+	a_pub_decode, \
+	a_pub_encode, \
+	a_pub_cmp, \
+	a_pub_print, \
+	a_priv_decode, \
+	a_priv_encode, \
+	a_priv_print, \
+	a_pkey_size, \
+	a_pkey_bits, \
+	a_param_decode, \
+	a_param_encode, \
+	a_param_missing, \
+	a_param_copy, \
+	a_param_cmp, \
+	a_param_print, \
+	a_pkey_free, \
+	a_pkey_ctrl, \
+	a_old_priv_decode, \
+	a_old_priv_encode \
+) \
+	OPENSSL_PREFIX_CONST_ITEM(extern, EVP_PKEY_ASN1_METHOD, cname, libopeay) \
+		CONST_ITEM_ENTRY_START( pkey_id,         a_pkey_id) \
+		CONST_ITEM_ENTRY_SINGLE(pkey_base_id,    a_pkey_base_id) \
+		CONST_ITEM_ENTRY_SINGLE(pkey_flags,      a_pkey_flags) \
+		CONST_ITEM_ENTRY_SINGLE(pem_str,         a_pem_str) \
+		CONST_ITEM_ENTRY_SINGLE(info,            a_info) \
+		CONST_ITEM_ENTRY_SINGLE(pub_decode,      a_pub_decode) \
+		CONST_ITEM_ENTRY_SINGLE(pub_encode,      a_pub_encode) \
+		CONST_ITEM_ENTRY_SINGLE(pub_cmp,         a_pub_cmp) \
+		CONST_ITEM_ENTRY_SINGLE(pub_print,       a_pub_print) \
+		CONST_ITEM_ENTRY_SINGLE(priv_decode,     a_priv_decode) \
+		CONST_ITEM_ENTRY_SINGLE(priv_encode,     a_priv_encode) \
+		CONST_ITEM_ENTRY_SINGLE(priv_print,      a_priv_print) \
+		CONST_ITEM_ENTRY_SINGLE(pkey_size,       a_pkey_size) \
+		CONST_ITEM_ENTRY_SINGLE(pkey_bits,       a_pkey_bits) \
+		CONST_ITEM_ENTRY_SINGLE(param_decode,    a_param_decode) \
+		CONST_ITEM_ENTRY_SINGLE(param_encode,    a_param_encode) \
+		CONST_ITEM_ENTRY_SINGLE(param_missing,   a_param_missing) \
+		CONST_ITEM_ENTRY_SINGLE(param_copy,      a_param_copy) \
+		CONST_ITEM_ENTRY_SINGLE(param_cmp,       a_param_cmp) \
+		CONST_ITEM_ENTRY_SINGLE(param_print,     a_param_print) \
+		CONST_ITEM_ENTRY_SINGLE(pkey_free,       a_pkey_free) \
+		CONST_ITEM_ENTRY_SINGLE(pkey_ctrl,       a_pkey_ctrl) \
+		CONST_ITEM_ENTRY_SINGLE(old_priv_decode, a_old_priv_decode) \
+		CONST_ITEM_ENTRY_SINGLE(old_priv_encode, a_old_priv_encode) \
+	CONST_ITEM_ENTRY_END
+
 /* Method to handle CRL access.
  * In general a CRL could be very large (several Mb) and can consume large
  * amounts of resources if stored in memory by multiple processes.
@@ -132,3 +188,20 @@
 				ASN1_INTEGER *ser, X509_NAME *issuer);
 	int (*crl_verify)(X509_CRL *crl, EVP_PKEY *pk);
 	};
+
+#define CONST_X509_CRL_METHOD_ITEM(cname, \
+	a_flags, \
+	a_crl_init, \
+	a_crl_free, \
+	a_crl_lookup, \
+	a_crl_verify \
+) \
+	OPENSSL_PREFIX_CONST_ITEM(extern, X509_CRL_METHOD, cname, libopeay) \
+		CONST_ITEM_ENTRY_START( flags,         a_flags) \
+		CONST_ITEM_ENTRY_SINGLE(crl_init,      a_crl_init) \
+		CONST_ITEM_ENTRY_SINGLE(crl_free,      a_crl_free) \
+		CONST_ITEM_ENTRY_SINGLE(crl_lookup,    a_crl_lookup) \
+		CONST_ITEM_ENTRY_SINGLE(crl_verify,    a_crl_verify) \
+	CONST_ITEM_ENTRY_END
+
+#endif // !HEADER_ASN1_LOCL_H
diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn1_mac.h openssl-1.0.0q/crypto/asn1/asn1_mac.h
--- openssl-1.0.0q.orig/crypto/asn1/asn1_mac.h	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn1_mac.h	2017-04-25 16:23:39.876527600 +0200
@@ -95,6 +95,7 @@
 	if (a != NULL) (*a)=ret; \
 	return(ret);
 
+#ifndef OPERA_SMALL_VERSION
 #define M_ASN1_D2I_Finish(a,func,e) \
 	M_ASN1_D2I_Finish_2(a); \
 err:\
@@ -102,6 +103,14 @@
 	asn1_add_error(*(const unsigned char **)pp,(int)(c.q- *pp)); \
 	if ((ret != NULL) && ((a == NULL) || (*a != ret))) func(ret); \
 	return(NULL)
+#else
+#define M_ASN1_D2I_Finish(a,func,e) \
+	M_ASN1_D2I_Finish_2(a); \
+err:\
+	ASN1_MAC_H_err((e),c.error,c.line); \
+	if ((ret != NULL) && ((a == NULL) || (*a != ret))) func(ret); \
+	return(NULL)
+#endif /* OPERA_SMALL_VERSION */
 
 #define M_ASN1_D2I_start_sequence() \
 	if (!asn1_GetSequence(&c,&length)) \
@@ -257,7 +266,7 @@
 #define M_ASN1_D2I_get_imp_set(r,func,free_func,a,b) \
 	c.q=c.p; \
 	if (d2i_ASN1_SET(&(r),&c.p,c.slen,(char *(*)())func,\
-		(void (*)())free_func,a,b) == NULL) \
+		(void (*)(void *))free_func,a,b) == NULL) \
 		{ c.line=__LINE__; goto err; } \
 	c.slen-=(c.p-c.q);
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn1_par.c openssl-1.0.0q/crypto/asn1/asn1_par.c
--- openssl-1.0.0q.orig/crypto/asn1/asn1_par.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn1_par.c	2017-04-25 16:23:39.879528540 +0200
@@ -56,12 +56,15 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include <openssl/objects.h>
 #include <openssl/asn1.h>
 
+#ifndef OPERA_SMALL_VERSION
 static int asn1_print_info(BIO *bp, int tag, int xclass,int constructed,
 	int indent);
 static int asn1_parse2(BIO *bp, const unsigned char **pp, long length,
@@ -69,8 +72,8 @@
 static int asn1_print_info(BIO *bp, int tag, int xclass, int constructed,
 	     int indent)
 	{
-	static const char fmt[]="%-18s";
-	char str[128];
+	const char* fmt="%-18s";
+	char str[128]; /* ARRAY OK 2007-04-23 yngve */
 	const char *p;
 
 	if (constructed & V_ASN1_CONSTRUCTED)
@@ -92,6 +95,8 @@
 	else
 		p = ASN1_tag2str(tag);
 
+	str[sizeof(str)-1] = '\0'; /* Just to be on the safe side */
+
 	if (BIO_printf(bp,fmt,p) <= 0)
 		goto err;
 	return(1);
@@ -414,10 +419,12 @@
 	*pp=p;
 	return(ret);
 	}
+#endif /* !OPERA_SMALL_VERSION */
 
+#ifndef OPERA_SMALL_VERSION
 const char *ASN1_tag2str(int tag)
 {
-	static const char * const tag2str[] = {
+	const char * const tag2str[] = {
 	 "EOC", "BOOLEAN", "INTEGER", "BIT STRING", "OCTET STRING", /* 0-4 */
 	 "NULL", "OBJECT", "OBJECT DESCRIPTOR", "EXTERNAL", "REAL", /* 5-9 */
 	 "ENUMERATED", "<ASN1 11>", "UTF8STRING", "<ASN1 13>", 	    /* 10-13 */
@@ -434,4 +441,5 @@
 	if(tag < 0 || tag > 30) return "(unknown)";
 	return tag2str[tag];
 }
+#endif /* !OPERA_SMALL_VERSION */
 
